var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var abc_accordion_group_exports = {};
__export(abc_accordion_group_exports, {
  AbcAccordionGroup: () => AbcAccordionGroup,
  defineCustomElement: () => defineCustomElement
});
module.exports = __toCommonJS(abc_accordion_group_exports);
var import_client = require("@stencil/core/internal/client");
const accordionGroupCss = ":host{box-sizing:border-box;display:flex;flex-direction:column;gap:20px;padding:0}";
const isHTMLAbcAccordionItemElement = (element) => {
  if (typeof element === "object" && typeof element.item === "string") {
    return true;
  }
  return false;
};
const AccordionContainer = /* @__PURE__ */ (0, import_client.proxyCustomElement)(class AccordionContainer2 extends import_client.HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.accordionChange = (0, import_client.createEvent)(this, "accordionChange", 7);
    this.selectedAccordion = void 0;
  }
  onAccordionChange() {
    this.accordionChange.emit(this.selectedAccordion);
    if (typeof this.selectedAccordion === "string") {
      const activeAccordion = this.getItems(this.selectedAccordion);
      this.accordions.forEach((accordion) => {
        if ((activeAccordion === null || activeAccordion === void 0 ? void 0 : activeAccordion.item) !== accordion.item) {
          accordion.open = false;
        }
      });
    }
  }
  get accordions() {
    return Array.from(this.host.querySelectorAll("abc-accordion"));
  }
  getItems(accordion) {
    return isHTMLAbcAccordionItemElement(accordion) ? accordion : this.accordions.find((t) => t.item === accordion);
  }
  select(item) {
    if (this.selectedAccordion === item) {
      return false;
    }
    this.selectedAccordion = item;
    return true;
  }
  render() {
    return (0, import_client.h)(import_client.Host, { onAccordionClick: ({ detail: { item, open } }) => {
      if (open) {
        this.select(item);
      }
    } }, (0, import_client.h)("slot", { name: "accordions" }));
  }
  get host() {
    return this;
  }
  static get watchers() {
    return {
      "selectedAccordion": ["onAccordionChange"]
    };
  }
  static get style() {
    return accordionGroupCss;
  }
}, [1, "abc-accordion-group", {
  "selectedAccordion": [513, "selected-accordion"]
}, void 0, {
  "selectedAccordion": ["onAccordionChange"]
}]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["abc-accordion-group"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "abc-accordion-group":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, AccordionContainer);
        }
        break;
    }
  });
}
const AbcAccordionGroup = AccordionContainer;
const defineCustomElement = defineCustomElement$1;
