var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var abc_accordion_exports = {};
__export(abc_accordion_exports, {
  AbcAccordion: () => AbcAccordion,
  defineCustomElement: () => defineCustomElement
});
module.exports = __toCommonJS(abc_accordion_exports);
var import_client = require("@stencil/core/internal/client");
var import_chevron_down = require("./chevron-down.js");
var ACCORDION_VARIANTS;
(function(ACCORDION_VARIANTS2) {
  ACCORDION_VARIANTS2["WHITE"] = "white";
  ACCORDION_VARIANTS2["GREY"] = "grey";
})(ACCORDION_VARIANTS || (ACCORDION_VARIANTS = {}));
const accordionCss = ":host .accordion{box-sizing:border-box;border-radius:5px;overflow:hidden;border-width:1px}:host .accordion__summary{display:flex;align-items:center;justify-content:space-between;padding:10px 15px;font:14px Arial, sans-serif;font-weight:700;word-break:break-all}:host .accordion__summary:hover{transition:0.3s}:host .accordion__paragraph{margin:0;padding:0 15px 10px 15px;word-break:break-all;max-height:0}:host .accordion__icon{align-self:flex-start;transition:0.5s}:host([variant=white]) .accordion{background-color:#ffffff;border-color:#ccc;font:16px Arial, sans-serif}:host([variant=white]) .accordion__icon{height:24px;width:24px;color:#333}:host([variant=white]) .accordion__summary{color:#333}:host([variant=white]) .accordion__summary:hover{color:#555;background-color:#f5f5f5;border-color:#666}:host([variant=white][open]) .accordion{background-color:#ffffff;color:#333;font:16px Arial, sans-serif}:host([variant=white][open]) .accordion__summary{color:#333}:host([variant=white][open]) .accordion__summary:hover{color:#555;background-color:#f5f5f5}:host([variant=white][open]) .accordion__icon{height:24px;width:24px;color:#333;transform:rotate(180deg)}:host([variant=grey]) .accordion{background-color:#ccc;border-color:#999;font:16px Arial, sans-serif}:host([variant=grey]) .accordion__summary{color:#333}:host([variant=grey]) .accordion__summary:hover{color:#555;background-color:#ddd;border-color:#666}:host([variant=grey]) .accordion__icon{height:24px;width:24px;color:#333}:host([variant=grey][open]) .accordion{background-color:#ccc;font:16px Arial, sans-serif}:host([variant=grey][open]) .accordion__summary{color:#333}:host([variant=grey][open]) .accordion__summary:hover{color:#555;background-color:#ddd}:host([variant=grey][open]) .accordion__icon{height:24px;width:24px;color:#333;transform:rotate(180deg)}details>summary::-webkit-details-marker{display:none}:host([open]) .accordion__paragraph{max-height:100vh;transition:0.5s}";
const Accordion = /* @__PURE__ */ (0, import_client.proxyCustomElement)(class Accordion2 extends import_client.HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.accordionClick = (0, import_client.createEvent)(this, "accordionClick", 7);
    this.open = false;
    this.variant = ACCORDION_VARIANTS.WHITE;
    this.summary = void 0;
    this.item = void 0;
  }
  componentDidLoad() {
    const { previousSibling, nextSibling, shadowRoot } = this.host;
    const detailsElement = shadowRoot === null || shadowRoot === void 0 ? void 0 : shadowRoot.querySelector("details");
    if (detailsElement) {
      if (previousSibling) {
        detailsElement.style.borderTopLeftRadius = "0";
        detailsElement.style.borderTopRightRadius = "0";
      }
      if (nextSibling) {
        detailsElement.style.borderBottomLeftRadius = "0";
        detailsElement.style.borderBottomRightRadius = "0";
      }
    }
  }
  render() {
    return (0, import_client.h)("details", { class: "accordion", open: this.open, "aria-expanded": this.open, onToggle: (event) => {
      this.open = event.target.open;
      this.accordionClick.emit({ open: this.open, item: this.item });
    } }, (0, import_client.h)("summary", { class: "accordion__summary" }, this.summary, (0, import_client.h)("abc-icon-chevron-down", { class: "accordion__icon" })), (0, import_client.h)("p", { class: "accordion__paragraph" }, (0, import_client.h)("slot", { name: "details" })));
  }
  get host() {
    return this;
  }
  static get style() {
    return accordionCss;
  }
}, [1, "abc-accordion", {
  "open": [516],
  "variant": [513],
  "summary": [1],
  "item": [513]
}]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["abc-accordion", "abc-icon-chevron-down"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "abc-accordion":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, Accordion);
        }
        break;
      case "abc-icon-chevron-down":
        if (!customElements.get(tagName)) {
          (0, import_chevron_down.d)();
        }
        break;
    }
  });
}
const AbcAccordion = Accordion;
const defineCustomElement = defineCustomElement$1;
