var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var abc_button_exports = {};
__export(abc_button_exports, {
  AbcButton: () => AbcButton,
  defineCustomElement: () => defineCustomElement
});
module.exports = __toCommonJS(abc_button_exports);
var import_client = require("@stencil/core/internal/client");
var BUTTON_VARIANTS;
(function(BUTTON_VARIANTS2) {
  BUTTON_VARIANTS2["PRIMARY"] = "primary";
  BUTTON_VARIANTS2["SECONDARY"] = "secondary";
  BUTTON_VARIANTS2["TERTIARY"] = "tertiary";
  BUTTON_VARIANTS2["QUATERNARY"] = "quaternary";
})(BUTTON_VARIANTS || (BUTTON_VARIANTS = {}));
var BUTTON_SIZES;
(function(BUTTON_SIZES2) {
  BUTTON_SIZES2["SM"] = "sm";
  BUTTON_SIZES2["MD"] = "md";
  BUTTON_SIZES2["LG"] = "lg";
})(BUTTON_SIZES || (BUTTON_SIZES = {}));
var BUTTON_TYPE;
(function(BUTTON_TYPE2) {
  BUTTON_TYPE2["BUTTON"] = "button";
  BUTTON_TYPE2["LINK"] = "link";
})(BUTTON_TYPE || (BUTTON_TYPE = {}));
const isExternalUrl = (href) => {
  if (typeof window === "undefined") {
    throw new Error("window is not defined");
  }
  try {
    const base = new URL(`${window.location.protocol}//${window.location.host}`);
    return new URL(href, base).origin !== location.origin;
  } catch (e) {
    return false;
  }
};
const buttonCss = ":host .button{align-items:center;box-sizing:border-box;cursor:pointer;display:inline-flex;max-width:100%;text-align:center;text-decoration:none;justify-content:center;transition:color linear 0.2s}:host .button:focus-visible{border-radius:4px;outline-color:#0078d4;outline-style:solid;outline-width:2px;outline-offset:2px}:host .button:hover{transition:0.3s}:host .button__icon{display:flex;align-items:center}:host([variant=primary][size=sm]) .button{font:14px Arial, sans-serif;color:#fff;background-color:#0078d4;border:1px solid #0078d4;border-radius:4px;padding:5px 10px;gap:5px}:host([variant=primary][size=sm]) .button:hover{color:#fff;background-color:#005a9e;border:1px solid #005a9e;border-radius:4px;padding:5px 10px}:host([variant=primary][size=sm]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:5px 10px}:host([variant=secondary][size=sm]) .button{font:14px Arial, sans-serif;color:#333;background-color:#ccc;border:1px solid #ccc;border-radius:4px;padding:5px 10px;gap:5px}:host([variant=secondary][size=sm]) .button:hover{color:#333;background-color:#999;border:1px solid #999;border-radius:4px;padding:5px 10px}:host([variant=secondary][size=sm]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:5px 10px}:host([variant=tertiary][size=sm]) .button{font:14px Arial, sans-serif;color:#0078d4;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=tertiary][size=sm]) .button:hover{color:#005a9e}:host([variant=tertiary][size=sm]) .button:disabled{color:#ccc}:host([variant=quaternary][size=sm]) .button{font:14px Arial, sans-serif;color:#333;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=quaternary][size=sm]) .button:hover{color:#999}:host([variant=quaternary][size=sm]) .button:disabled{color:#ccc}:host([variant=primary][size=md]) .button{font:16px Arial, sans-serif;color:#fff;background-color:#0078d4;border:1px solid #0078d4;border-radius:4px;padding:7px 14px;gap:5px}:host([variant=primary][size=md]) .button:hover{color:#fff;background-color:#005a9e;border:1px solid #005a9e;border-radius:4px;padding:7px 14px}:host([variant=primary][size=md]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:7px 14px}:host([variant=secondary][size=md]) .button{font:16px Arial, sans-serif;color:#333;background-color:#ccc;border:1px solid #ccc;border-radius:4px;padding:7px 14px;gap:5px}:host([variant=secondary][size=md]) .button:hover{color:#333;background-color:#999;border:1px solid #999;border-radius:4px;padding:7px 14px}:host([variant=secondary][size=md]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:7px 14px}:host([variant=tertiary][size=md]) .button{font:16px Arial, sans-serif;color:#0078d4;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=tertiary][size=md]) .button:hover{color:#005a9e}:host([variant=tertiary][size=md]) .button:disabled{color:#ccc}:host([variant=quaternary][size=md]) .button{font:16px Arial, sans-serif;color:#333;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=quaternary][size=md]) .button:hover{color:#999}:host([variant=quaternary][size=md]) .button:disabled{color:#ccc}:host([variant=primary][size=lg]) .button{font:18px Arial, sans-serif;color:#fff;background-color:#0078d4;border:1px solid #0078d4;border-radius:4px;padding:9px 18px;gap:5px}:host([variant=primary][size=lg]) .button:hover{color:#fff;background-color:#005a9e;border:1px solid #005a9e;border-radius:4px;padding:9px 18px}:host([variant=primary][size=lg]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:9px 18px}:host([variant=secondary][size=lg]) .button{font:18px Arial, sans-serif;color:#333;background-color:#ccc;border:1px solid #ccc;border-radius:4px;padding:9px 18px;gap:5px}:host([variant=secondary][size=lg]) .button:hover{color:#333;background-color:#999;border:1px solid #999;border-radius:4px;padding:9px 18px}:host([variant=secondary][size=lg]) .button:disabled{color:#ccc;background-color:#f0f0f0;border:1px solid #ccc;border-radius:4px;padding:9px 18px}:host([variant=tertiary][size=lg]) .button{font:18px Arial, sans-serif;color:#0078d4;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=tertiary][size=lg]) .button:hover{color:#005a9e}:host([variant=tertiary][size=lg]) .button:disabled{color:#ccc}:host([variant=quaternary][size=lg]) .button{font:18px Arial, sans-serif;color:#333;background-color:transparent;border:none;padding:0;gap:5px}:host([variant=quaternary][size=lg]) .button:hover{color:#999}:host([variant=quaternary][size=lg]) .button:disabled{color:#ccc}";
const Button = /* @__PURE__ */ (0, import_client.proxyCustomElement)(class Button2 extends import_client.HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.disabled = false;
    this.variant = BUTTON_VARIANTS.PRIMARY;
    this.size = BUTTON_SIZES.MD;
    this.type = "submit";
    this.as = BUTTON_TYPE.BUTTON;
    this.href = void 0;
    this.ariaLabel = void 0;
    this.target = "_self";
  }
  isExternalURL() {
    return isExternalUrl(this.href);
  }
  render() {
    if (this.as === BUTTON_TYPE.BUTTON) {
      return (0, import_client.h)("button", { part: "button", class: "button", type: this.type, disabled: this.disabled }, (0, import_client.h)("slot", null));
    }
    return (0, import_client.h)("a", { part: "button", class: "button", href: this.href, "aria-label": this.ariaLabel, target: this.target, rel: this.isExternalURL() ? "noreferrer" : void 0 }, (0, import_client.h)("slot", null));
  }
  static get style() {
    return buttonCss;
  }
}, [1, "abc-button", {
  "disabled": [4],
  "variant": [513],
  "size": [513],
  "type": [1],
  "as": [513],
  "href": [1],
  "ariaLabel": [1, "aria-label"],
  "target": [1]
}]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["abc-button"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "abc-button":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, Button);
        }
        break;
    }
  });
}
const AbcButton = Button;
const defineCustomElement = defineCustomElement$1;
