'use client';

import { defineCustomElement } from './components/abc-accordion.js';
import React, { useEffect, useRef, useState } from 'react';

export const AbcAccordionUseClient = ({
  ssrHtml,
  children,
  ...props
}) => {
  const refPlaceholder = useRef(null);
  const [isClient, setIsClient] = useState(false);
  useEffect(() => {
    refPlaceholder.current?.remove();
    if (typeof customElements !== 'undefined' && !customElements.get('abc-accordion')) {
      defineCustomElement();
    }
    setIsClient(true);
  }, []);


  return React.createElement('div', { children: [
    React.createElement('div', { ref: refPlaceholder, key: 'abc-accordion-placeholder', dangerouslySetInnerHTML: { __html: ssrHtml } }),
    isClient && React.createElement('abc-accordion', { ...props, key: 'abc-accordion' }, children),
  ]});
};