import { renderToString } from './hydrate';
import { AbcFlyoutItemUseClient } from './abc-flyout-item.use-client';
import React from 'react';

export const AbcFlyoutItemSSR = async ({ children, ...props }) => {
  const { html } = await renderToString(
    `<abc-flyout-item ${Object.entries(props)
  .map(([key, value]) => `${key}="${value}"`)
  .join(' ')}>${children}</abc-flyout-item>`,
  );
  const componentStyles = html.match(/<style[^>]*>([\s\S]*?)<\/style>/i)?.[1] ?? '';
  const componentHtml = html.match(/<body[^>]*>([\s\S]*?)<\/body/i)?.[1] ?? '';

  return React.createElement(AbcFlyoutItemUseClient, { ...props, children, ssrHtml: `<style>${componentStyles}</style>${componentHtml}` });
};