'use client';

import React, { useImperativeHandle, useRef, useEffect } from 'react';
import { defineCustomElement } from './components/abc-icon-chevron-down.js';
import { omitEventCallbacks, toNativeProps, useEventListeners } from './lib/utils.js';

const customEvents = [];
const AbcIconChevronDown = React.forwardRef(({ children = [], ...props }, ref) => {
  const nativeProps = toNativeProps(omitEventCallbacks(customEvents, props));
  if (typeof window !== 'undefined') {
    const innerRef = useRef();
    useImperativeHandle(ref, () => innerRef.current);
    useEventListeners(innerRef, customEvents, props);
    useEffect(() => {
      if (typeof customElements !== 'undefined' && !customElements.get('abc-icon-chevron-down')) {
        defineCustomElement();
      }
    }, []);

    return React.createElement('abc-icon-chevron-down', { ...nativeProps, ref: innerRef }, children);
  }

  return React.createElement('abc-icon-chevron-down', { ...nativeProps, ref }, children);
});

export { AbcIconChevronDown };
