import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

var ICON_SIZES;
(function (ICON_SIZES) {
    ICON_SIZES["XS"] = "xs";
    ICON_SIZES["SM"] = "sm";
    ICON_SIZES["MD"] = "md";
    ICON_SIZES["LG"] = "lg";
    ICON_SIZES["XL"] = "xl";
    ICON_SIZES["XXL"] = "xxl";
})(ICON_SIZES || (ICON_SIZES = {}));

const iconsCss = ":host{box-sizing:border-box;display:flex;align-items:center;justify-content:center}:host([size=xs]) svg{height:16px;width:16px}:host([size=sm]) svg{height:24px;width:24px}:host([size=md]) svg{height:32px;width:32px}:host([size=lg]) svg{height:40px;width:40px}:host([size=xl]) svg{height:48px;width:48px}:host([size=xxl]) svg{height:56px;width:56px}";

const AbcIconChevronDown = /*@__PURE__*/ proxyCustomElement(class AbcIconChevronDown extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.size = ICON_SIZES.MD;
    }
    render() {
        switch (this.size) {
            case ICON_SIZES.XS:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 16 16", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "1.5", d: "m4 6 4 4 4-4" })));
            case ICON_SIZES.SM:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 24 24", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "2", d: "m6 9 6 6 6-6" })));
            case ICON_SIZES.MD:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 32 32", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "2.3", d: "m8 12 8 8 8-8" })));
            case ICON_SIZES.LG:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 40 40", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "2.5", d: "m10 15 10 10 10-10" })));
            case ICON_SIZES.XL:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 48 48", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "3", d: "m12 18 12 12 12-12" })));
            case ICON_SIZES.XXL:
                return (h("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 56 56", "stroke-linejoin": "round", "stroke-linecap": "round", stroke: "currentColor", fill: "none" }, h("path", { "stroke-width": "3.5", d: "m14 21 14 14 14-14" })));
        }
    }
    static get style() { return iconsCss; }
}, [1, "abc-icon-chevron-down", {
        "size": [513]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["abc-icon-chevron-down"];
    components.forEach(tagName => { switch (tagName) {
        case "abc-icon-chevron-down":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, AbcIconChevronDown);
            }
            break;
    } });
}

export { AbcIconChevronDown as A, ICON_SIZES as I, defineCustomElement as d };

//# sourceMappingURL=chevron-down.js.map